#include "systemc.h"

typedef enum{ add_op = 0, sub_op = 1, jmp_op = 2 } isa_t;


#define ADD 0x00
#define SUB 0x40
#define JMP 0x80

SC_MODULE(processor){
  sc_in<bool> clk;
  sc_in<bool> reset;
  sc_out<sc_uint<8> > acc;
  sc_out<sc_uint<8> > ip;

  sc_signal< sc_uint< 8 > > reg_acc,reg_ip;
  sc_signal< sc_uint< 8 > > opcode,operand;
  sc_signal< sc_uint< 8 > > memory[8];


  void logic(){
    memory[0] = ADD | 1;
    memory[1] = ADD | 2;
    memory[2] = SUB | 1;

    acc = reg_acc;
    ip = reg_ip;

    if( reset.read() ){
      reg_ip.write(0);
      reg_acc.write(0);
    }
    else{
      opcode = memory[ reg_ip.read() ].range( 7, 6 );
      reg_ip = reg_ip.read() + 1;

      switch( opcode.read() ){
      case add_op : {
	reg_acc = reg_acc.read() + operand.read();
	break;
      }
      case sub_op : {
	reg_acc = reg_acc.read() - operand.read();
	break;
      }
      case jmp_op : {
	reg_ip = operand;
	break;
      }
      default : {
	
      }
      };
    }

  }

  SC_CTOR(processor){
    SC_METHOD(logic);
    sensitive << clk.pos();
  }

};


