// Generated by CynthVLG 2.5.1  (091704)
// Thu Mar  9 17:11:15 2006
// from dct.cpp
      
module bitrev(in, out);

      input [4:0] in;
      output [4:0] out;
      reg [4:0] out;
      reg[4:0] a;

         always @(in)
          begin :update
            a = in;
            1'b0[1'b0] = a[4'd4];
            1'b0[2'd1] = a[3'd3];
            1'b0[3'd2] = a[3'd2];
            1'b0[3'd3] = a[2'd1];
            1'b0[4'd4] = a[1'b0];
            out = 5'd0;
         end


endmodule

      
module psi(in, out);

      input [4:0] in;
      output [4:0] out;
      reg [4:0] out;
      reg[4:0] a;
      reg[4:0] b;

         always @(in)
          begin :update
            a = in;
            b = 5'd0;
            b[4] = a[0];
            b[1'b0] = a[2'd1] ^ a[0];
            b[2'd1] = a[3'd2] ^ a[0];
            b[3'd2] = a[3'd3] ^ a[0];
            b[3'd3] = a[4'd4] ^ a[0];
            out = b;
         end


endmodule

      
module multiplier_28_32(a, b, c);

      input [31:0] a;
      input [31:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[30:0] abs_b;
      reg[28:0] aux;
      reg[61:0] abs_temp;
      reg sign_temp;
      reg[62:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[31];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[30:0];
            end
            else begin
               abs_b = b[30:0];
            end
            aux = 29'd0;
            aux[27] = 1'b1;
            abs_temp = {31'b0, abs_a}*{31'b0, abs_b} + {33'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[59:28];
         end


endmodule

      
module multiplier_16_18(a, b, c);

      input [31:0] a;
      input [17:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[16:0] abs_b;
      reg[16:0] aux;
      reg[47:0] abs_temp;
      reg sign_temp;
      reg[48:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[17];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[16:0];
            end
            else begin
               abs_b = b[16:0];
            end
            aux = 17'd0;
            aux[15] = 1'b1;
            abs_temp = {17'b0, abs_a}*{31'b0, abs_b} + {31'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[47:16];
         end


endmodule

      
module dct(clk, Reset_n, in_trans, out_ready, data_in, in_nch, data_out, out_trans, in_ready, out_nch);

      input clk;
      input Reset_n;
      input in_trans;
      input out_ready;
      input [31:0] data_in;
      input [1:0] in_nch;
      output [31:0] data_out;
      reg [31:0] data_out;
      output out_trans;
      reg out_trans;
      output in_ready;
      reg in_ready;
      output [1:0] out_nch;
      reg [1:0] out_nch;
      wire[31:0] y_out;
      wire[4:0] br_a;
      wire[4:0] br_b;
      wire[4:0] psi_i;
      wire[4:0] br_psi_i;
      wire[31:0] mul_c;
      /*signed*/reg[31:0] state;
      reg estado_read;
      reg estado_write;
      reg y_we;
      reg[31:0] costab[31:0];
      reg[4:0] y_addr;
      reg[31:0] y_in;
      reg[4:0] i;
      reg[3:0] j;
      reg[3:0] k;
      reg[4:0] ki;
      reg[2:0] li;
      reg[4:0] kmax;
      reg[4:0] a;
      reg[4:0] b;
      reg[31:0] mul_a;
      reg[31:0] mul_b;
      reg[4:0] cos_index;
      reg[1:0] nch;
      reg[31:0] temp;

         always @(ki or j or i or a or k or li or br_a or br_b or br_psi_i or state or estado_read or estado_write or in_trans or in_nch or nch or temp or y_addr or y_out or mul_c or y_we or data_in)
          begin :comb_signals
            costab[1'b0] = 32'd0;
            costab[2'd1] = 32'd189812531;
            costab[3'd2] = 32'd248002024;
            costab[3'd3] = 32'd4192241495;
            costab[4'd4] = 32'd263277544;
            costab[4'd5] = 32'd149134749;
            costab[4'd6] = 32'd4242598137;
            costab[4'd7] = 32'd4071771372;
            costab[5'd8] = 32'd267142866;
            costab[5'd9] = 32'd236738937;
            costab[5'd10] = 32'd170293651;
            costab[5'd11] = 32'd77922700;
            costab[5'd12] = 32'd4268656021;
            costab[5'd13] = 32'd4168427699;
            costab[5'd14] = 32'd4087463883;
            costab[5'd15] = 32'd4038090582;
            costab[6'd16] = 32'd268112114;
            costab[6'd17] = 32'd260390782;
            costab[6'd18] = 32'd242662778;
            costab[6'd19] = 32'd215609380;
            costab[6'd20] = 32'd180270234;
            costab[6'd21] = 32'd138003405;
            costab[6'd22] = 32'd90433181;
            costab[6'd23] = 32'd39387662;
            costab[6'd24] = 32'd4281795793;
            costab[6'd25] = 32'd4229742802;
            costab[6'd26] = 32'd4180196351;
            costab[6'd27] = 32'd4135060483;
            costab[6'd28] = 32'd4096069744;
            costab[6'd29] = 32'd4064722526;
            costab[6'd30] = 32'd4042223487;
            costab[6'd31] = 32'd4029437249;
            y_we <= 1'd0; //default
            if (state == 32'd0 && in_trans && i == 5'd0) begin
               nch <= in_nch;
            end
            out_nch = nch;
            a <= ki + {1'b0, j};
            b <= a + i;
            ki <= k<<li;
            kmax <= 7'd32>>li;
            out_trans = |(state == 32'd6 ? 32'd1 : 32'd0);
            cos_index <= {1'b0, j} + i;
            data_out = y_out;
            in_ready = |{1'b0, state == 32'd0};
            mul_a <= costab[cos_index];
            mul_b <= temp - y_out;
            case (state) 

               32'd0: begin
                  y_in <= data_in;
                  y_addr <= br_psi_i;
                  y_we <= 1'd1;
               end
               
               32'd1: begin
                  y_addr <= br_a;
               end
               
               32'd2: begin
                  y_we <= 1'd1;
                  y_addr <= br_b;
                  y_in <= mul_c;
               end
               
               32'd3: begin
                  y_we <= 1'd1;
                  y_addr <= br_a;
                  y_in <= temp;
               end
               
               32'd4: begin
                  y_addr <= ki - i + {1'b0, j};
               end
               
               32'd5: begin
                  y_we <= 1'd1;
                  y_addr <= ki + {1'b0, j} + i;
                  y_in <= 32'd2*y_out - temp;
               end
               
               32'd6: begin
                  y_addr <= i;
               end
               
            endcase

         end

         bitrev bitrev0(.in(psi_i), .out(br_psi_i));

         bitrev bitrev1(.in(a), .out(br_a));

         bitrev bitrev2(.in(b), .out(br_b));

         psi psi0(.in(i), .out(psi_i));

         multiplier_28_32 mul0(.a(mul_a), .b(mul_b), .c(mul_c));

         yram yram0(.clk(clk), .addr(y_addr), .we(y_we), .in_data(y_in), .out_data(y_out));

         always @(posedge(clk))
          begin :fsm
            if (Reset_n == 1'b0) begin
               state <= 32'd0;
               i <= 5'd0;
               j <= 4'd0; //don't care
               k <= 4'd0; //don't care
               li <= 3'd0; //don't care
            end
            else begin
               case (state) 

                  32'd0: begin
                     if (in_trans) begin
                        if (i == 5'd31) begin
                           state <= 32'd1;
                           i <= 5'd16;
                        end
                        else begin
                           i <= i + 5'd1;
		//printf("in_dct %d %d\n", (int)i.read(), (int)data_in.read());
                           state <= 32'd0;
                        end
                     end
                     li <= 3'd5;
                     j <= 4'd0;
                     k <= 4'd0;
                  end
                  
                  32'd1: begin
                     temp <= y_out;
                     state <= 32'd2;
                  end
                  
                  32'd2: begin
                     temp <= temp + y_out;
                     state <= 32'd3;
                  end
                  
                  32'd3: begin
                     state <= 32'd1;
                     if ({2'b0, j} == {1'b0, i} - 6'd1) begin
                        j <= 4'd0;
                        if ({2'b0, k} == {1'b0, kmax} - 6'd1) begin
                           if (i == 5'd1) begin
                              i <= 5'd8;
                              k <= 4'd1;
                              li <= 3'd4;
                              state <= 32'd4;
                           end
                           else begin
                              li <= li - 3'd1;
                              k <= 4'd0;
                              i <= i>>1'b1;
                           end
                        end
                        else begin
                           k <= k + 4'd1;
                        end
                     end
                     else begin
                        j <= j + 4'd1;
                     end
                  end
                  
                  32'd4: begin
                     state <= 32'd5;
                     temp <= y_out;
                  end
                  
                  32'd5: begin
                     state <= 32'd4;
                     if ({2'b0, j} == {1'b0, i} - 6'd1) begin
                        j <= 4'd0;
                        if ({2'b0, k} == {1'b0, kmax} - 6'd1) begin
                           k <= 4'd1;
                           i <= i>>1'b1;
                           li <= li - 3'd1;
                           if (i == 5'd1) begin
                              state <= 32'd6;
                           end
                        end
                        else begin
                           k <= k + 4'd1;
                        end
                     end
                     else begin
                        j <= j + 4'd1;
                     end
                  end
                  
                  32'd6: begin
                     if (out_ready) begin
                        i <= i + 5'd1;
                        if (i == 5'd31) begin
                           state <= 32'd0;
                        end
                     end
                  end
                  
               endcase

            end
         end


endmodule

