// Generated by CynthVLG 2.5.1  (091704)
// Thu Mar  9 17:16:05 2006
// from imdctwindow.cpp
      
module multiplier_28_32(a, b, c);

      input [31:0] a;
      input [31:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[30:0] abs_b;
      reg[28:0] aux;
      reg[61:0] abs_temp;
      reg sign_temp;
      reg[62:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[31];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[30:0];
            end
            else begin
               abs_b = b[30:0];
            end
            aux = 29'd0;
            aux[27] = 1'b1;
            abs_temp = {31'b0, abs_a}*{31'b0, abs_b} + {33'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[59:28];
         end


endmodule

      
module multiplier_16_18(a, b, c);

      input [31:0] a;
      input [17:0] b;
      output [31:0] c;
      reg [31:0] c;
      reg sign_b;
      reg sign_a;
      reg[30:0] abs_a;
      reg[16:0] abs_b;
      reg[16:0] aux;
      reg[47:0] abs_temp;
      reg sign_temp;
      reg[48:0] temp;

         always @(a or b)
          begin :mul
            sign_a = a[31];
            sign_b = b[17];
            if (sign_a) begin
               abs_a = -a[30:0];
            end
            else begin
               abs_a = a[30:0];
            end
            if (sign_b) begin
               abs_b = -b[16:0];
            end
            else begin
               abs_b = b[16:0];
            end
            aux = 17'd0;
            aux[15] = 1'b1;
            abs_temp = {17'b0, abs_a}*{31'b0, abs_b} + {31'b0, aux};
            sign_temp = sign_a ^ sign_b;
            if (sign_temp) begin
               temp = -{1'b0, abs_temp};
            end
            else begin
               temp = {1'b0, abs_temp};
            end
            c = temp[47:16];
         end


endmodule

      
module memoria_rom(clk, addr, out_data);

      input clk;
      input [5:0] addr;
      output [31:0] out_data;
      reg [31:0] out_data;
      reg[31:0] buff[47:0];

         always @(posedge(clk))
          begin :sync_proc
            buff[1'b0] = 32'd11708990;
            buff[2'd1] = 32'd35037858;
            buff[3'd2] = 32'd58100066;
            buff[3'd3] = 32'd80720098;
            buff[4'd4] = 32'd102725802;
            buff[4'd5] = 32'd123949700;
            buff[4'd6] = 32'd144230265;
            buff[4'd7] = 32'd163413152;
            buff[5'd8] = 32'd181352365;
            buff[5'd9] = 32'd197911378;
            buff[5'd10] = 32'd212964166;
            buff[5'd11] = 32'd226396167;
            buff[5'd12] = 32'd238105157;
            buff[5'd13] = 32'd248002024;
            buff[5'd14] = 32'd256011445;
            buff[5'd15] = 32'd262072464;
            buff[6'd16] = 32'd266138953;
            buff[6'd17] = 32'd268179965;
            buff[6'd18] = 32'd268179965;
            buff[6'd19] = 32'd266138953;
            buff[6'd20] = 32'd262072464;
            buff[6'd21] = 32'd256011445;
            buff[6'd22] = 32'd248002024;
            buff[6'd23] = 32'd238105157;
            buff[6'd24] = 32'd226396167;
            buff[6'd25] = 32'd212964166;
            buff[6'd26] = 32'd197911378;
            buff[6'd27] = 32'd181352365;
            buff[6'd28] = 32'd163413152;
            buff[6'd29] = 32'd144230265;
            buff[6'd30] = 32'd123949700;
            buff[6'd31] = 32'd102725802;
            buff[7'd32] = 32'd80720098;
            buff[7'd33] = 32'd58100066;
            buff[7'd34] = 32'd35037858;
            buff[7'd35] = 32'd11708990;
            buff[7'd36] = 32'd35037858;
            buff[7'd37] = 32'd102725802;
            buff[7'd38] = 32'd163413152;
            buff[7'd39] = 32'd212964166;
            buff[7'd40] = 32'd248002024;
            buff[7'd41] = 32'd266138953;
            buff[7'd42] = 32'd266138953;
            buff[7'd43] = 32'd248002024;
            buff[7'd44] = 32'd212964166;
            buff[7'd45] = 32'd163413152;
            buff[7'd46] = 32'd102725802;
            buff[7'd47] = 32'd35037858;
/* WINDOW SHORT 0-11 */
            out_data <= buff[addr];
         end


endmodule

      
// Estados
module imdctwindow(clk, Reset_n, data_in, in_nch, in_block_type, in_trans, in_ready, data_out, out_nch, out_trans, out_ready);

      input clk;
      input Reset_n;
      input [31:0] data_in;
      input [1:0] in_nch;
      input [1:0] in_block_type;
      input in_trans;
      input out_ready;
      output in_ready;
      reg in_ready;
      output [31:0] data_out;
      reg [31:0] data_out;
      output [1:0] out_nch;
      reg [1:0] out_nch;
      output out_trans;
      reg out_trans;
  // Sinais do IMDCT
  // Sinais do Overlap
  // Sinais internos
  // Buffer -> memoria ROM
      wire[31:0] buf_rom_out;
  // Buffer -> memoria RAM
      wire[31:0] buf_ram_out;
  // Multiplier
      wire[31:0] mul_c;
      /*signed*/reg[31:0] state;
      /*signed*/reg[31:0] next_state;
      reg read_on_ram;
      reg bt2;
      reg wait_0;
      reg buf_ram_we;
      reg[5:0] i;
      reg[15:0] j;
      reg[1:0] nch;
      reg[1:0] block_type;
      reg[31:0] data_ant;
      reg[31:0] mul_c_ant;
      reg[5:0] buf_rom_addr;
      reg[31:0] buf_ram_in;
      reg[2:0] buf_ram_addr;
      reg[31:0] mul_a;
      reg[31:0] mul_b;

//#define DEBUG_MODE
         always @(posedge(clk))
          begin :fsm
            if (Reset_n == 1'b0) begin
    // Inicializacao das variaveis
               in_ready <= 1'd0;
               out_trans <= 1'd0;
               j <= 16'd0;
               buf_ram_we <= 1'd0;
               buf_ram_addr <= 3'd0;
               buf_ram_in <= 32'd0;
               buf_rom_addr <= 6'd0;
               mul_a <= 32'd0;
               mul_b <= 32'd0;
               wait_0 <= 1'd0;
               bt2 <= 1'd0;
               read_on_ram <= 1'd0;
               data_ant <= 32'd0;
               i <= 6'd0;
               data_out <= 32'd0;
               block_type <= in_block_type;
               out_nch <= in_nch;
               nch <= in_nch;
               next_state <= 32'd8;
               state <= 32'd0;
            end
            else begin
               case (state) 

                  32'd0: begin
                     out_trans <= 1'd0;
                     in_ready <= 1'd1; // Pronto para ler
                     wait_0 <= 1'd0;
                     bt2 <= 1'd0;
                     buf_ram_we <= 1'd0;
                     mul_c_ant <= 32'd0;
                     mul_a <= data_in;
                     data_ant <= data_in;
                     read_on_ram <= 1'd0;
      // Leitura do numero de canais "in_nch" e block type. Repasse nch para saida
                     if (i == 6'd0 && {1'b0, in_trans} == 2'd1) begin
                        nch <= in_nch;
                        out_nch <= in_nch;
                        block_type <= in_block_type;
                        j <= 16'd1 + j;
	//     printf("DUVim%d ", (int)j.read());
                     end
                     else begin
                        out_nch <= nch;
                        nch <= nch;
                        block_type <= block_type;
                     end
      // Verifica se os dados de entrada sao validos
                     if ({1'b0, in_trans} == 2'd1) begin
                        case (in_block_type) 

                           2'd0: begin
                              data_out <= data_out; //
                              buf_rom_addr <= i;
                              buf_ram_addr <= buf_ram_addr; //
                              state <= 32'd4;
                              next_state <= 32'd8;
                              if (i != 6'd35) begin
                                 i <= i + 6'd1;
                              end
                              else begin
                                 i <= 6'd0;
                              end
                           end
                           
                           2'd1: begin
                              if (i < 6'd18) begin
                                 data_out <= data_out; //
                                 buf_rom_addr <= i;
                                 state <= 32'd4;
                              end
                              else begin
                                 if (i >= 6'd18 && i < 6'd24) begin
                                    data_out <= data_in;
                                    buf_rom_addr <= buf_rom_addr; //
                                    wait_0 <= 1'd1;
                                    state <= 32'd8;
                                 end
                                 else begin
                                    if (i >= 6'd24 && i < 6'd30) begin
                                       data_out <= data_out; //
                                       buf_rom_addr <= i - 6'd18 + 6'd36;
                                       state <= 32'd4;
                                    end
                                    else begin
                                       if (i >= 6'd30 && i < 6'd36) begin
                                          data_out <= 32'd0;
                                          buf_rom_addr <= buf_rom_addr; //
                                          wait_0 <= 1'd1;
                                          state <= 32'd8;
                                       end
                                    end
                                 end
                              end
                              buf_ram_addr <= buf_ram_addr; //       
                              next_state <= 32'd8;
                              if (i != 6'd35) begin
                                 i <= i + 6'd1;
                              end
                              else begin
                                 i <= 6'd0;
                              end
                           end
                           
                           2'd3: begin
                              if (i < 6'd6) begin
                                 data_out <= 32'd0;
                                 buf_rom_addr <= buf_rom_addr; // 
                                 wait_0 <= 1'd1;
                                 state <= 32'd8;
                              end
                              else begin
                                 if (i >= 6'd6 && i < 6'd12) begin
                                    data_out <= data_out; //
                                    buf_rom_addr <= i - 6'd6 + 6'd36;
                                    state <= 32'd4;
                                 end
                                 else begin
                                    if (i >= 6'd12 && i < 6'd18) begin
                                       data_out <= data_in;
                                       buf_rom_addr <= buf_rom_addr; //
                                       wait_0 <= 1'd1;
                                       state <= 32'd8;
                                    end
                                    else begin
                                       if (i >= 6'd18 && i < 6'd36) begin
                                          data_out <= data_out; //
                                          buf_rom_addr <= i;
                                          state <= 32'd4;
                                       end
                                    end
                                 end
                              end
                              buf_ram_addr <= buf_ram_addr; // 
                              next_state <= 32'd8;
	    //prox_read = 0;
                              if (i != 6'd35) begin
                                 i <= i + 6'd1;
                              end
                              else begin
                                 i <= 6'd0;
                              end
                           end
                           
                           2'd2: begin
                              if (i < 6'd6) begin
                                 data_out <= 32'd0;
                                 buf_rom_addr <= buf_rom_addr; //
                                 buf_ram_addr <= i[2:0];
                                 state <= 32'd9;
                                 next_state <= 32'd8;
                              end
                              else begin
                                 if (i >= 6'd6 && i < 6'd12) begin
                                    buf_rom_addr <= i - 6'd6 + 6'd36;
                                    buf_ram_addr <= i[2:0] - 3'd6;
                                    read_on_ram <= 1'd1;
                                    state <= 32'd4;
                                    next_state <= 32'd10;
                                 end
                                 else begin
                                    if (i >= 6'd12 && i < 6'd18) begin
                                       data_out <= data_out; //
                                       buf_rom_addr <= i - 6'd12 + 6'd36;
                                       buf_ram_addr <= buf_ram_addr; //
                                       read_on_ram <= 1'd0;
                                       state <= 32'd4;
                                       next_state <= 32'd10;
                                    end
                                    else begin
                                       if (i >= 6'd18 && i < 6'd24) begin
                                          data_out <= data_out; // 
                                          buf_rom_addr <= buf_rom_addr; //
                                          buf_ram_addr <= i[2:0] - 3'd2;
                                          wait_0 <= 1'd1;
                                          state <= 32'd9;
                                          next_state <= 32'd0;
                                       end
                                       else begin
                                          if (i >= 6'd24 && i < 6'd30) begin
                                             data_out <= data_out; // 
                                             buf_rom_addr <= i - 6'd24 + 6'd36;
                                             buf_ram_addr <= buf_ram_addr; //
                                             state <= 32'd4;
                                             read_on_ram <= 1'd0;
                                             next_state <= 32'd10;
                                          end
                                          else begin
                                             if (i >= 6'd30 && i < 6'd36) begin
                                                data_out <= data_out; // 
                                                buf_rom_addr <= i - 6'd24 + 6'd36; //----------------------
                                                buf_ram_addr <= buf_ram_addr; //
                                                state <= 32'd4;
                                                read_on_ram <= 1'd0;
                                                if (i == 6'd35) begin
                                                   bt2 <= 1'd1;
                                                end
                                                else begin
                                                   bt2 <= 1'd0;
                                                end
                                                next_state <= 32'd8;
                                             end
                                          end
                                       end
                                    end
                                 end
                              end
                              i <= i + 6'd1;
                           end
                           
                        endcase

                        in_ready <= 1'd0;
                     end
                     else begin
                        data_out <= data_out; //
                        buf_rom_addr <= buf_rom_addr; //
                        buf_ram_addr <= buf_ram_addr; //
                        state <= 32'd0;
                        next_state <= 32'd8; //
                        i <= i; //
                     end
                  end
                  
                  32'd4: begin
      // Enviando o endereço desejado para memoria
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     buf_ram_we <= 1'd0;
                     state <= 32'd5;
                  end
                  
                  32'd5: begin
      // Lendo a memoria e preparando o dado a ser enviado
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     buf_ram_we <= 1'd0;
                     if (read_on_ram) begin
                        mul_a <= buf_ram_out;
                     end
                     else begin
                        mul_a <= mul_a;
                     end
                     mul_b <= buf_rom_out;
                     state <= 32'd6;
                  end
                  
                  32'd6: begin
      // Lendo a memoria e preparando o dado a ser enviado
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     buf_ram_we <= 1'd0;
                     data_out <= mul_c + mul_c_ant;
                     state <= next_state;
                  end
                  
                  32'd8: begin
                     in_ready <= 1'd0;
                     buf_ram_we <= 1'd0;
                     out_trans <= 1'd1;
                     if ({1'b0, out_ready} == 2'd1) begin
                        if ({1'b0, bt2} == 2'd1) begin
                           state <= 32'd10;
                        end
                        else begin
                           state <= 32'd0;
                           in_ready <= 1'd1;
                        end
                     end
                     else begin
                        state <= 32'd8;
                     end
                  end
                  
                  32'd9: begin
                     out_trans <= 1'd0;
                     buf_ram_in <= data_ant; //////////
                     buf_ram_we <= 1'd1;
                     state <= next_state;
                     if (next_state == 32'd0) begin
                        in_ready <= 1'd1;
                     end
                     else begin
                        in_ready <= 1'd0;
                     end
                  end
                  
                  32'd10: begin
                     buf_ram_we <= 1'd0;
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     bt2 <= 1'd0;
                     wait_0 <= 1'd0;
                     if (i >= 6'd7 && i < 6'd13) begin
                        read_on_ram <= 1'd0;
                        data_out <= data_out; //
                        buf_rom_addr <= buf_rom_addr; //
                        buf_ram_addr <= i[2:0] - 3'd7;
                        state <= 32'd9;
                        next_state <= 32'd8;
                     end
                     else begin
                        if (i >= 6'd13 && i < 6'd19) begin
                           buf_rom_addr <= i - 6'd7 + 6'd36;
                           buf_ram_addr <= i[2:0] - 3'd5;
                           read_on_ram <= 1'd1;
                           mul_c_ant <= mul_c;
                           state <= 32'd4;
                           next_state <= 32'd8;
                        end
                        else begin
                           if (i >= 6'd25 && i < 6'd31) begin
                              buf_rom_addr <= i - 6'd25 + 6'd36 + 6'd6;
                              buf_ram_addr <= i[2:0] - 3'd1;
                              read_on_ram <= 1'd1;
                              mul_c_ant <= mul_c;
                              state <= 32'd4;
                              next_state <= 32'd8;
                           end
                           else begin
                              if (i >= 6'd36 && i < 6'd43) begin
                                 bt2 <= 1'd1;
                                 data_out <= 32'd0;
                                 buf_rom_addr <= buf_rom_addr; // 
                                 buf_ram_addr <= buf_ram_addr; // 
                                 next_state <= 32'd8; //
                                 if (i != 6'd42) begin
                                    i <= i + 6'd1;
                                    state <= 32'd8;
                                 end
                                 else begin
                                    i <= 6'd0;
                                    in_ready <= 1'd1;
                                    state <= 32'd0;
                                 end
                              end
                           end
                        end
                     end
                  end
                  
                  default: begin
                     in_ready <= 1'd0;
                     out_trans <= 1'd0;
                     buf_ram_we <= 1'd0;
                     buf_ram_addr <= 3'd0;
                     buf_ram_in <= 32'd0;
                     buf_rom_addr <= 6'd0;
                     mul_a <= 32'd0;
                     mul_b <= 32'd0;
                     read_on_ram <= 1'd0;
                     data_ant <= 32'd0;
                     i <= 6'd0;
                     data_out <= 32'd0;
                     block_type <= in_block_type;
                     out_nch <= in_nch;
                     nch <= in_nch;
                     wait_0 <= 1'd0;
                     bt2 <= 1'd0;
                     next_state <= 32'd8;
                     state <= 32'd0;
                  end
                  
               endcase

            end
         end

         memoria_rom buf0(.clk(clk), .addr(buf_rom_addr), .out_data(buf_rom_out));

         memoria_ram buf1(.clk(clk), .addr(buf_ram_addr), .we(buf_ram_we), .in_data(buf_ram_in), .out_data(buf_ram_out));

         multiplier_28_32 mul0(.a(mul_a), .b(mul_b), .c(mul_c));


endmodule

