#ifndef IMDCTWINDOW_BUF_H
#define IMDCTWINDOW_BUF_H
#include <systemc.h>
//#include "asyncram.h"
#include "syncram.h"
//#include "syncrom.h"
#include <assert.h>

#ifdef SIMULATION
#define SIM_ASSERT(size)   assert(addr.read() < size)
#else
#define SIM_ASSERT(size)
#endif

// creates a 6x32 RAM
DEFINE_SYNCRAM(6, sc_uint<32>, sc_uint<3>, memoria_ram);


SC_MODULE(memoria_rom){
  sc_in<bool>            clk;
  sc_in<sc_uint<6> >     addr;
  sc_out<sc_uint<32> >     out_data;

  void sync_proc();

  SC_CTOR(memoria_rom){
    SC_METHOD(sync_proc);
    sensitive_pos << clk;
  }
};


/*
#define DEFINE_SYNCROM(size, elem_type, index_type, rom_name ) \
        SC_MODULE(rom_name){\
          sc_in<bool>            clk;\
          sc_in<index_type >     addr;\
          sc_out<elem_type >     out_data;\
          void sync_proc();\
          SC_CTOR(rom_name){\
            SC_METHOD(sync_proc);\
            sensitive_pos << clk;\
          }\
	};

*/

//DEFINE_SYNCROM(48, sc_uint<32>, sc_uint<6>, memoria_rom);


#endif
