// Generated by CynthVLG 2.5.1  (091704)
// Thu Mar  9 17:14:39 2006
// from overlap.cpp
      
// Estados
module overlap(clk, reset_n, data_in, in_trans, out_ready, in_nch, out_nch, in_ready, out_trans, data_out);

      input clk;
      input reset_n;
      input [31:0] data_in;
      input in_trans;
      input out_ready;
      input [1:0] in_nch;
      output [1:0] out_nch;
      reg [1:0] out_nch;
      output in_ready;
      reg in_ready;
      output out_trans;
      reg out_trans;
      output [31:0] data_out;
      reg [31:0] data_out;
  // Entradas (IMDCT window)
  // Saidas (reorder)
  // Sinais internos da maquina de estados
  // Buffer -> memória RAM
      wire[31:0] buf_out;
      reg inverte;
      /*signed*/reg[31:0] state;
      reg ch;
      reg buf_we;
      reg[1:0] nch;
      reg[5:0] i;
      reg[4:0] sb;
      reg[1:0] valid_ch;
      reg[5:0] valid_sb;
      reg[31:0] data_ant;
      reg[31:0] a;
      reg[31:0] buf_in;
      reg[10:0] buf_addr;

/*
  Faz a sobreposição (soma) da primeira metade dos sinais de um canal com a segunda metade do anterior
  
  Responsável : André Costa - andre.lnc@gmail.com
*/
         always @(posedge(clk))
          begin :fsm
            if (reset_n == 1'b0) begin
    // Inicialização das variáveis
               in_ready <= 1'd0;
               out_trans <= 1'd0;
               buf_we <= 1'd0;
               buf_addr <= 11'd0;
               buf_in <= 32'd0;
               data_ant <= 32'd0;
               i <= 6'd0;
               sb <= 5'd0;
               ch <= 1'd0;
               valid_ch <= 2'd0;
               valid_sb <= 6'd0;
               state <= 32'd1;
            end
            else begin
               case (state) 

                  32'd1: begin
                     buf_we <= 1'd0;
                     out_trans <= 1'd0;
                     in_ready <= 1'd1; // Pronto para ler
    // Verifica se os dados de entrada são válidos
                     if ({1'b0, in_trans} == 2'd1) begin
      // Primeira metade dos sinais (Leia e prepare para escrever na saída)
                        if (i < 6'd18) begin
	// Se já existir dados válidos no buffer, então faça a soma, senão apenas repasse os dados
                           if ({1'b0, ch} < valid_ch && {1'b0, sb} < valid_sb) begin
                              data_ant <= data_in;
                              buf_addr <= {5'b0, i}*11'd32*11'd2 + {10'b0, ch}*11'd32 + {6'b0, sb};
                              if (sb & 5'd1 && i & 6'd1) begin
                                 inverte <= 1'd1;
                              end
                              else begin
                                 inverte <= 1'd0;
                              end
                              state <= 32'd2;
                           end
                           else begin
                              if (sb & 5'd1 && i & 6'd1) begin
                                 data_out <= -data_in;
                              end
                              else begin
                                 data_out <= data_in;
                              end
                              state <= 32'd3;
                           end
	// Leitura do numero de canais "in_nch" e repasse para saída
                           if (i == 6'd0 && sb == 5'd0 && ch == 1'b0) begin
                              nch <= in_nch;
                              out_nch <= in_nch;
                           end
                           else begin
                              out_nch <= nch;
                              nch <= nch;
                           end
	// Atualiza os valores "i, sb, ch"
                           if (i != 6'd35) begin
                              i <= i + 6'd1;
                           end
                           else begin
                              i <= 6'd0;
                           end
                           if (i == 6'd35) begin
                              if (sb != 5'd31) begin
                                 sb <= sb + 5'd1;
                              end
                              else begin
                                 sb <= 5'd0;
                              end
                              if (sb == 5'd31) begin
                                 if ({2'b0, ch} != {1'b0, nch} - 3'd1) begin
                                    ch <= |({2'b0, ch} + 3'd1);
                                 end
                                 else begin
                                    ch <= 1'd0;
                                 end
                              end
                           end
                           in_ready <= 1'd0;
                        end
                        else begin
        // Segunda metade dos sinais (Leia e armazene no buffer)
	// Preparando para armazenar os dados no buffer
                           data_out <= 32'd0;
                           buf_addr <= ({5'b0, i} - 11'd18)*11'd32*11'd2 + {10'b0, ch}*11'd32 + {6'b0, sb};
                           data_ant <= data_in;
                           in_ready <= 1'd0;
                           state <= 32'd0;
	// Atualiza os valores "i, sb, ch, valid_sb, valid_ch"
                           if (i != 6'd35) begin
                              i <= i + 6'd1;
                           end
                           else begin
                              i <= 6'd0;
                              a <= a + 32'd1;
                           end
                           if (i == 6'd35) begin
                              if (sb != 5'd31) begin
                                 sb <= sb + 5'd1;
                              end
                              else begin
                                 sb <= 5'd0;
                              end
                              if (valid_sb != 6'd32) begin
                                 valid_sb <= valid_sb + 6'd1;
                              end
                              if (sb == 5'd31) begin
                                 if (valid_ch == 2'd2 || nch == 2'd2 && {1'b0, ch} == 2'd1) begin
                                    valid_ch <= 2'd2;
                                 end
                                 else begin
                                    valid_ch <= 2'd1;
                                 end
                                 if ({2'b0, ch} != {1'b0, nch} - 3'd1) begin
                                    ch <= |({2'b0, ch} + 3'd1);
                                 end
                                 else begin
                                    ch <= 1'd0;
                                 end
                              end
                           end
                        end
                     end
                     else begin
                        state <= 32'd1;
                     end
                  end
                  
                  32'd0: begin
    // Armazenando os dados no buffer
                     out_trans <= 1'd0;
                     in_ready <= 1'd1;
                     buf_in <= data_ant;
                     buf_we <= 1'd1;
                     state <= 32'd1;
                  end
                  
                  32'd2: begin
    // Enviando o endereço desejado para memoria
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     buf_we <= 1'd0;
                     state <= 32'd4;
                  end
                  
                  32'd4: begin
    // Lendo a memoria e preparando o dado a ser enviado
                     out_trans <= 1'd0;
                     in_ready <= 1'd0;
                     buf_we <= 1'd0;
                     if (inverte) begin
                        data_out <= -data_ant - buf_out;
                     end
                     else begin
                        data_out <= data_ant + buf_out;
                     end
                     state <= 32'd3;
                  end
                  
                  32'd3: begin
    // Escrevendo na saída
                     buf_we <= 1'd0;
                     out_trans <= 1'd1;
                     if ({1'b0, out_ready} == 2'd1) begin
                        state <= 32'd1;
                        in_ready <= 1'd1;
                     end
                     else begin
                        state <= 32'd3;
                        in_ready <= 1'd0;
                     end
                  end
                  
               endcase

            end
         end

         initial begin
            a <= 32'd0;
         end

         memoria_ram_overlap buf0(.clk(clk), .addr(buf_addr), .we(buf_we), .in_data(buf_in), .out_data(buf_out));


endmodule

