
#ifndef REORDER_H
#define REORDER_H
#include <systemc.h>
#include "reorder_buf.h"

SC_MODULE(reorder){

  enum state_st {read_st = 0, read_st_w, write_st, write_st_w, write_st_ww};

  sc_in<bool>          clk;
  sc_in<bool>          Reset_n;
  sc_in<sc_uint<2> >   in_nch;
  sc_out<sc_uint<2> >  out_nch;
  sc_in<sc_uint<32> >  data_in;
  sc_in<bool>          in_trans;
  sc_in<bool>          out_ready;
  sc_out<bool>         in_ready;
  sc_out<bool>         out_trans;
  sc_out<sc_uint<32> > data_out;

  sc_signal<sc_uint<32> > data_out_m;
  sc_signal<sc_uint<32> >  data_in_m;
  sc_signal<sc_uint<32> >  data_ant;
  memoria_ram_reorder *buf0;
  sc_signal<sc_uint<12> > buf_addr;
  sc_signal<bool>         buf_we;

  sc_signal<sc_uint<10> >      i;
  sc_signal<sc_uint<10> >      j;
  sc_signal<sc_uint<10> >      k;
  sc_signal<sc_uint<10> >      gr;
  sc_signal<sc_uint<2> >       nch;
  sc_signal<state_st>          state;
  sc_signal<state_st>          next_state;
  sc_signal<bool>                 prox_read;

   sc_signal<int>      a;
   sc_signal<int>      b;

  void fsm();

  //reorder(sc_module_name mod_reorder);
  SC_CTOR( reorder )
  {
      b = 0;
      buf0 = new memoria_ram_reorder("buf0");
      buf0->clk(clk);
      buf0->addr(buf_addr);
      buf0->we(buf_we);
      buf0->in_data(data_in_m);
      buf0->out_data(data_out_m);
      SC_METHOD(fsm);
      sensitive_pos << clk;
    }


};
#endif
